#!/usr/bin/perl
use strict;
$|=1;

# This is a simple script for extracting target names from our
# makefile.  It's useful when you don't want to go to the trouble of
# creating a new collection of pseudo-targets.  If significant changes
# are made to createUnifiedMakefile.pl, this script will have to
# change too.

# USAGE EXAMPLE:
#   make `./filtermake.pl cpu 20080211 _error`

my $fetcherCmd = join " ", "make -n", (map { "| grep $_" } @ARGV, "hostname");
my @targets = (grep { $_ = (/\.[^\/]+$/ ? $_ : "$_.txt") } 
               grep { /\/scratch/; $_ = "/scratch$'" } 
               grep { s/\.log$// } 
               split "\n", `$fetcherCmd`);
print join("\n", reverse @targets)."\n";

