#ifndef _LEAR_DRAW_BEST_THRESH_H_
#define _LEAR_DRAW_BEST_THRESH_H_

#include <string>
#include <lear/classifier/ppresult.h>

namespace lear {
  /**
  Creates an "image" where the value at every pixel location is the highest 
  classifier score achieved there.  The results are saved to .mat files.
  This processor should usually go after non-maxima suppression.
  */
  struct DrawBestThreshold : public PostProcessResult {
    typedef PostProcessResult  Parent;
    DrawBestThreshold(std::string const outmat_,
                      bool        const outfileIsDir_,
                      std::string const &tag_);

    virtual void write(const_iterator s, const_iterator e, 
                       RGBImage    const &inimage,
                       std::string const &filename);

    bool static verifyImageOut(std::string const outmat_,
                               bool const outfileIsDir_);

    virtual std::string toString() { 
      return "Draw Best Threshold Post Process Result";
    }

  protected:
    std::string const outmat_;
    bool        const outfileIsDir_;
    std::string const tag_;
  };
}
#endif // _LEAR_MARK_IMAGE_H_
