#ifndef _LEAR_HISTOGRAM_PROCESS_RESULT_H_
#define _LEAR_HISTOGRAM_PROCESS_RESULT_H_

#include <lear/cvision/dhistogram.h>
#include <lear/classifier/histprocessor.h>
#include <lear/classifier/th_processresult.h>

namespace lear {
  // Histogram accumulator.  Writes out histogram upon destruction.
  struct Hist_ProcessResult : public Threshold_ProcessResult, public HistProcessor {
  public:
    typedef Threshold_ProcessResult                Parent;
    typedef Threshold_ProcessResult::RealType      RealType;

    static RealType const DefaultMinTh;
    static RealType const DefaultExtTh;
    static RealType const DefaultBandwidth;

    Hist_ProcessResult(std::string const &histfile_,
                       RealType    const threshold_,
                       int         const label_,
                       RealType    const minTh_ = DefaultMinTh,
                       RealType    const extTh_ = DefaultExtTh, 
                       RealType    const bandwidth_ = DefaultBandwidth):
      
    Parent(threshold_,label_),
      HistProcessor(histfile_,minTh_,extTh_,bandwidth_)
    {}

    virtual bool operator()(DetectInfo const &r) {
      HistProcessor::operator()(r.score);
      return Parent::operator()(r);
    }

    virtual std::string toString() { 
      return "Histogram Process Result"; 
    }
  };
}
#endif //_LEAR_HISTOGRAM_PROCESS_RESULT_H_
