#ifndef _LEAR_SCORE_LIST_PROCESS_RESULT_H_
#define _LEAR_SCORE_LIST_PROCESS_RESULT_H_

#include <lear/cvision/dhistogram.h>
#include <lear/classifier/th_processresult.h>

namespace lear {
  struct ScoreList_ProcessResult : public Threshold_ProcessResult {
  public:
    typedef Threshold_ProcessResult                    Parent;

    ScoreList_ProcessResult(
      std::string const &listfile_, RealType const threshold_)
      : Parent(threshold_), to(listfile_.c_str())
    {
      if (!to) ThrowException("Unable to open output file " + listfile_);
    }

    virtual bool operator()(DetectInfo const &r){
      to << r.score << std::endl;
      return Parent::operator()(r);
    }

    virtual std::string toString() { 
      return "Score List Process Result";
    }

  protected:
    /// output stream
    std::ofstream to;
  };
}
#endif //_LEAR_SCORE_LIST_PROCESS_RESULT_H_
