#ifndef _LEAR_TRACKER_PPRESULT_H_
#define _LEAR_TRACKER_PPRESULT_H_

#include "../../lib/cfg.h"
#ifdef HAVE_TRACKER
#include <lear/classifier/ppresult.h>
#include <tracker/JTracker.h>
#include <tracker/TrkOutputStream.h>
#include <memory>

namespace lear {
  struct Tracker_PPResult : public PostProcessResult {
    typedef PostProcessResult        Parent;
    typedef blitz::TinyVector<int,2> IndexType;

    // Takes ownership of tracker and trkoutput
    Tracker_PPResult(JTracker *tracker, ITrkOutputStream *trkoutput,
                     double fps, IndexType frameExtent) :
      frame(0), tracker(tracker), trkoutput(trkoutput), fps(fps),
      frameExtent(frameExtent) {}

    virtual void write(const_iterator s, const_iterator e,
                       RGBImage    const &inimage,
                       std::string const &filename);

    virtual std::string toString() {
      return "Kalman tracker Post Process Result";
    }
  private:
    int64                           frame;
    std::auto_ptr<JTracker>         tracker;
    std::auto_ptr<ITrkOutputStream> trkoutput;
    double                          fps;
    IndexType                       frameExtent; // -1 means use frame's size
  };
};

#endif
#endif
