#ifndef _LEAR_TYPES_H_
#define _LEAR_TYPES_H_

#include <limits>
#include <lear/exception.h>

namespace lear {

typedef signed   char  int8;
typedef unsigned char  uint8;
typedef signed   short int16;
typedef unsigned short uint16;
typedef signed   int   int32;
typedef unsigned int   uint32;
#if defined(WIN32) || defined(WIN64)
    typedef __int64 int64;
    typedef unsigned __int64 uint64;
#else
    typedef long long int64;
    typedef unsigned long long uint64;
#endif

// TODO: the boost people have to have done this before.  Later I can look for it.
template <typename TOut, typename TIn>
inline TOut range_cast(TIn in) {
  if (in < std::numeric_limits<TIn>::min()) {
    ThrowException(in << " is too small for a successful conversion");
  } else if (in > std::numeric_limits<TIn>::max()) {
    ThrowException(in << " is too large for a successful conversion");
  } else {
    return static_cast<TOut>(in);
  }
}

};

#endif
