#ifndef _LEAR_CUSTOM_OPTION_H_
#define _LEAR_CUSTOM_OPTION_H_

#include <vector>
#include <string>

namespace lear {
  class CustomOption {
  protected:
    typedef std::vector<unsigned>       OptionNumber;
    typedef std::vector<std::string>    OptionList;

    std::string         mesg_;
    unsigned            default_;
    OptionList          optlst_;
    OptionNumber        optnum_;

  public:
    std::string option;

    CustomOption(std::string const &mesg, unsigned default_=0) :
    mesg_(mesg), default_(default_)
    {}

    template<class optiter>
    CustomOption(std::string const &mesg, optiter start, optiter end) :
    mesg_(mesg) 
    {
      for (int i=0; start!=end ; ++start,++i){
        optlst_.push_back(*start);
        optnum_.push_back(i);
      }
    }

    // TODO: I think this should be expanded to have a help string, a string 
    // token, and a value. I believe the current implementation confounds the
    // help string and string token.  Example:
    //    opt.add("SVMLight",SVMLight,"SVMLight: Default svmlight format")
    CustomOption& add(std::string const &str, unsigned ref){
      optlst_.push_back(str); optnum_.push_back(ref);
      return *this;
    }

    bool validate(std::string const &which) const ;
    int check(std::string const &which) const ;
    int check() const { return check(option); }

    void clear() { optlst_.clear(); optnum_.clear(); }

    std::string usage() const ;
    std::string defaultOption() const ;
  };

}

#endif // _LEAR_COMMON_MAIN_H_
