#include <iostream>
#include <lear/exception.h>

#include <lear/classifier/list_ppresult.h>

using namespace std;

lear::List_PPResult::List_PPResult(std::string const &listfile_,
                                   int const marker,
                                   bool const writeFilename,
                                   int const verbose) :
  Parent(),
  to(listfile_.c_str()), marker(marker), writeFilename(writeFilename),
  verbose(verbose)
{
  using namespace std;
  if (!to) {
    ThrowException("Unable to open output file " + listfile_);
  }
}

void lear::List_PPResult::write(const_iterator s, const_iterator e, 
                                PostProcessResult::RGBImage const &inimage,
                                std::string                 const &infile)
{
  using namespace std;

  if (infile.size() == 0 || isspace(infile[0])) {
    ThrowException("Empty filename");
  }

  // Write divider row to signal a change in images
  to  << (writeFilename ? "DIVIDER" : "")
      << setw(6) << 0 << ' ' << setw(6) << 0 << ' ' 
      << setw(6) << 0 << ' ' << setw(6) << 0 << ' ' 
      << setw(6) << 0 << ' ' << setw(6) << 0 << ' '
      << setw(6) << 0 << '\n';
  // Write one line per detection
  size_t n=0;
  if (writeFilename) {
    for (; s != e; ++s, ++n) {
      to << infile << *s << " " << setw(3) << marker << endl;
    }
  } else {
    for (; s != e; ++s, ++n) {
      to  << *s << " " << setw(4) << marker << endl;
    }
  }
  to.flush();

  if (verbose >= 6) {
    cout << "  wrote " << n << " detections" << endl;
  }
}

