#ifndef PDCUDA_GRADIENTS_GOLD_H
#define PDCUDA_GRADIENTS_GOLD_H

#include <memory>

#include "types_gold.h"
#include "gradients.h"

namespace pdcuda {

  inline void computeColorGradientsCPU(Magnitude      *m, 
                                       Orientation    *o, 
                                       RGBImage const &i) 
  {
    using namespace lear;
    using namespace std;
    ImageNoRemap *mapperBefore(new ImageSqrtRemap());
    ImageNoRemap *mapperAfter(NULL);
    auto_ptr<IProcessor> preprocessor;
    preprocessor.reset(new GradProcessor_NoSmooth(SemiCirc, NULL, 
                                                  mapperBefore, mapperAfter));
  
    IProcessor::InfoType info = (*preprocessor)(i);

    m->reference(info.mag);
    o->reference(info.ori);
  }

};

#endif
