#ifndef PDCUDA_THREADS_H
#define PDCUDA_THREADS_H

// This header provides some simple wrappers around parts of the
// Boost.Threads library.  The nVidia CUDA Compiler (v2.1) cannot
// parse the boost header files, so these wrappers provide a way to
// access that functionality in .cu files.

namespace pdcuda {

  class ScopedLock;

  class Mutex {
  public:
    Mutex();
    ~Mutex();
  private:
    void *m;
    friend class ScopedLock;
  };

  class ScopedLock {
  public:
    ScopedLock(Mutex &m);
    ~ScopedLock();
  private:
    Mutex &m;
    void  *l;
  };

};

#endif
