function label = bboxLabel(bbox, posBboxes, isnear)
%label=bboxLabel(bbox, posBboxes, isnear)
%  Computes the label (0=negative, 1=positive) of a window given all of the
%  positive bounding boxes in an image.
%
%  BBOX         [xmin;ymin;xmax;ymax] of the bounding box in question
%  POSBBOXES    bounding boxes of all positive examples in this image,
%                 where each column is one bounding box
%  ISNEAR       function taking two bounding boxes that returns 0 if they
%                 are far from each other (according to whatever the user
%                 defines as "far") or 1 if they are near.
%
%EXAMPLE:
%  bbox = [0 0 1 1]';
%  pos  = [0 0 1 1; 10 10 11 11]' + 0.4;
%  bboxLabel(bbox, pos, isNearCtor('voc', 0.25)) % --> 1
%  bboxLabel(bbox, pos, isNearCtor('voc', 0.75)) % --> 0

label = false;
for i=1:size(posBboxes,2)
  if isnear(bbox,posBboxes(:,i))
    label = true;
    return
  end
end
