clear all;

% PASCAL Visual Object Challenge's definition of nearness
isnearVoc = isNearCtor('voc', 0.5);

% remove existing files
fclose all; clear all;
try delete(grandCentralDir('test/1159407741750/neg_*'));     catch end
try rmdir(grandCentralDir('test/1159407741750/neg_*'), 's'); catch end
try delete(grandCentralDir('test/20061026-metlife/neg_*'));       catch end
try rmdir(grandCentralDir('test/20061026-metlife/neg_*'), 's');   catch end

%                       basedir                                annoset     nmname    w  fh  fTop ip op  ss   es  N    Nr   isnear
%                       -------------------------------------  ----------  ------    -- --  ---- -- --  ---- --- ---  --   ---------
extractNegativeExamples(grandCentralDir('test/1159407741750'), '20080221', 'voc050', 32,96, 1,   16,16, 0.25,nan,200, 200, isnearVoc)
extractNegativeExamples(grandCentralDir('test/1159407741750'), '20080221', 'voc050', 32,96, 1/2, 16,16, 0.25,nan,200, 200, isnearVoc)
extractNegativeExamples(grandCentralDir('test/1159407741750'), '20080221', 'voc050', 32,96, 1/3, 16,16, 0.25,nan,200, 200, isnearVoc)
extractNegativeExamples(grandCentralDir('test/1159407741750'), '20080221', 'voc050', 32,96, 1/4, 16,16, 0.25,nan,200, 200, isnearVoc)

extractNegativeExamples(grandCentralDir('test/20061026-metlife'), '20080221', 'voc050', 32,96, 1,   16,16, 0.5,1.5,200, 200, isnearVoc)
extractNegativeExamples(grandCentralDir('test/20061026-metlife'), '20080221', 'voc050', 32,96, 1/2, 16,16, 0.5,1.5,200, 200, isnearVoc)
extractNegativeExamples(grandCentralDir('test/20061026-metlife'), '20080221', 'voc050', 32,96, 1/3, 16,16, 0.5,1.5,200, 200, isnearVoc)
extractNegativeExamples(grandCentralDir('test/20061026-metlife'), '20080221', 'voc050', 32,96, 1/4, 16,16, 0.5,1.5,200, 200, isnearVoc)

% extract small chips and create aliases for various window geometries
origdir = pwd;
basedirs = { ...
  grandCentralDir('test/1159407741750'),    '20080221';...
  grandCentralDir('test/20061026-metlife'), '20080221' };
for bi=1:size(basedirs,1);
  basedir = basedirs{bi,1};
  annoset = basedirs{bi,2};
  windowset = 'voc050';
  extractNegativeExamples(basedir,annoset,windowset,  8,24, 1, 4,3, 0.5,1.5,200, 200, isnearVoc)
  base = ['neg_' annoset '_w16x32c'];
  ext = ['_' windowset '.lst'];
  srclst = [base '8x8' ext];
  assert(exist(fullfile(basedir,srclst),'file')~=0,...
    'Could not find %s in "%s"', srclst, basedir);
  
  % 2x2 and 4x4 have the same sided windows
  for c=[2 4]
    cmd = ['cd ' linuxPath(basedir) '; ln -s  ' srclst '  ' base sprintf('%dx%d',c,c) ext];
    if ispc
      fprintf('%s\n', cmd);
    else
      system(cmd);
    end
  end
  
  % 6x6 has a smaller window
  c = 6;
  base = ['neg_' annoset '_w12x30c'];
  cmd = ['cd ' linuxPath(basedir) '; ln -s  ' srclst '  ' base sprintf('%dx%d',c,c) ext];
  if ispc
    fprintf('%s\n', cmd);
  else
    system(cmd);
  end
end
