function flat=flattenAnnotations(hier)
%flat=flattenAnnotations(hier)
%  Takes a hierarchical annotations structure and converts it into a flat
%  structure

flat = struct;
flat.imagename   = {};
flat.headcenters = zeros(2,0);
flat.bboxes      = zeros(4,0);

nimg = numel(hier);
nAnno = cellfun(@(elm) size(elm,2), {hier.headcenters});
idcs = [0 cumsum(nAnno)];
for iimg=1:nimg
  for ia=1:nAnno(iimg)
    i = ia + idcs(iimg);
    flat.imagename{i}      = hier(iimg).imagename;
    flat.headcenters(:,i)  = hier(iimg).headcenters(:,ia);
    flat.bboxes(:,i)       = hier(iimg).bboxes(:,ia);
  end
end
