function [X,I] = subsample_logx(x,SAMPLE,EPSILON) 
% Create equally spaced markers in log range of x SAMPLE samples and return the 
% new subsample values in X and corresponding indices in I

if (nargin < 2)
    SAMPLE=20;
end
if (nargin < 3)
    EPSILON=1e-8;
end

L = length(x);

ord = sort(x); ord = ord(ord > EPSILON);
minx=ord(1); lminx = log10(minx);
maxx = max(x); lmaxx = log10(maxx); 

bw = (lmaxx-lminx)/(SAMPLE-1);
ox=[lminx:bw:lmaxx];
ox = 10.^ox;
% disp(sprintf('bw %e, minx %e, maxx %e, lminx %e, lmaxx %e',...
%         bw,minx,maxx,lminx,lmaxx));

t = abs(x*ones(1,SAMPLE) - ones(L,1)*ox);
[X,I] = min(t);
X=x(I);

